#include <stdio.h>
#include <stdlib.h>

int randomBit() { return (rand()%2); }

// create a random integer number in [low, up)
int randomInteger(int low, int up) {
  return (int)( (double)(rand()/(RAND_MAX+1.0))*(up - low) ) + low;
}

// create a random double number in [low, up)
double randomNumber(double low, double up) {
  return ((double)rand()/(RAND_MAX+1.0))*(up - low) + low;  
}

int sign(double value) {
  if (value == 0.0) return 0; 
  else return (value > 0.0? 1 : -1);
}

void swap(int &x, int &y) {
  int temp;
  temp = x; x = y; y = temp;
}

void swap(double &x, double &y) {
  double temp;
  temp = x; x = y; y = temp;
}

int max(int x, int y) {
  return (x > y ? x : y);
}

/***********************************************************/
/* Random sequence generator:                              */
/*   Generates a random sequence of seqSize numbers from   */
/*   the natural number array [0, 1, ..., numSize-1]       */
/***********************************************************/
void randomSequence(int* seqArr, int seqSize, int numSize) {
  int i, j, idx, count, numleft;

  // constructs a natural number array
  int number[numSize];
  for (i=0; i<numSize; ++i) number[i] = i; 

  // select seqSize numbers from number[] without repeat
  numleft = numSize;
  for (i=0; i<seqSize; ++i) { 
    idx = rand()%numleft;
    count = 0;
    for (j=0; j<numSize; ++j) { 
      if (number[j] != -1)    // found one not selected number
        ++count;

      if (count > idx) break; // found the idx-th not selected number
    }

    seqArr[i] = number[j];
    number[j] = -1;           // marked as selected
    --numleft;
  }
}
